> ## Documentation Index
> Fetch the complete documentation index at: https://docs.paymnt.cloud/llms.txt
> Use this file to discover all available pages before exploring further.

# 3DS Decision - Execute



## OpenAPI

````yaml public/openapi.json post /three_ds_decision/execute
openapi: 3.0.3
info:
  title: PaymntCloud - API Documentation
  description: >

    ## Get started


    PaymntCloud provides a collection of APIs that enable you to process and
    manage payments.

    Our APIs accept and return JSON in the HTTP body, and return standard HTTP
    response codes.


    You can consume the APIs directly using your favorite HTTP/REST library.


    We have a testing environment referred to "sandbox", which you can setup to
    test API calls without

    affecting production data.

    Currently, our sandbox environment is live while our production environment
    is under development

    and will be available soon.

    You can sign up on our Dashboard to get API keys to access PaymntCloud API.


    ### Environment


    Use the following base URLs when making requests to the APIs:


    | Environment   |  Base URL                          |

    |---------------|------------------------------------|

    | Sandbox       | <https://sandbox.paymnt.cloud>   |

    | Production    | <https://api.paymnt.cloud>       |


    ## Authentication


    When you sign up on our [dashboard](https://dash.paymnt.cloud) and create a
    merchant

    account, you are given a secret key (also referred as api-key) and a
    publishable key.

    You may authenticate all API requests with PaymntCloud server by providing
    the appropriate key in

    the request Authorization header.


    | Key             | 
    Description                                                                                 
    |

    |-----------------|-----------------------------------------------------------------------------------------------|

    | api-key         | Private key. Used to authenticate all API requests from
    your merchant server                  |

    | publishable key | Unique identifier for your account. Used to authenticate
    API requests from your app's client  |


    Never share your secret api keys. Keep them guarded and secure.
  contact:
    name: PaymntCloud Support
    url: https://paymnt.cloud
    email: support@paymnt.cloud
  license:
    name: Apache-2.0
  version: 0.1.0
servers:
  - url: https://api.paymnt.cloud
    description: Production Environment
  - url: https://sandbox.paymnt.cloud
    description: Sandbox Environment
security: []
tags:
  - name: Merchant Account
    description: Create and manage merchant accounts
  - name: Profile
    description: Create and manage profiles
  - name: Merchant Connector Account
    description: Create and manage merchant connector accounts
  - name: Payments
    description: Create and manage one-time payments, recurring payments and mandates
  - name: Refunds
    description: Create and manage refunds for successful payments
  - name: Mandates
    description: Manage mandates
  - name: Customers
    description: Create and manage customers
  - name: Payment Methods
    description: Create and manage payment methods of customers
  - name: Disputes
    description: Manage disputes
  - name: API Key
    description: Create and manage API Keys
  - name: Payouts
    description: Create and manage payouts
  - name: payment link
    description: Create payment link
  - name: Routing
    description: Create and manage routing configurations
  - name: Event
    description: Manage events
  - name: Authentication
    description: Create and manage authentication
paths:
  /three_ds_decision/execute:
    post:
      tags:
        - 3DS Decision Rule
      summary: 3DS Decision - Execute
      operationId: Execute 3DS Decision Rule
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ThreeDsDecisionRuleExecuteRequest'
        required: true
      responses:
        '200':
          description: 3DS Decision Rule Executed Successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ThreeDsDecisionRuleExecuteResponse'
        '400':
          description: Bad Request
      security:
        - api_key: []
components:
  schemas:
    ThreeDsDecisionRuleExecuteRequest:
      type: object
      description: Represents the request to execute a 3DS decision rule.
      required:
        - routing_id
        - payment
      properties:
        routing_id:
          type: string
          description: The ID of the routing algorithm to be executed.
        payment:
          $ref: '#/components/schemas/PaymentData'
        payment_method:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodMetaData'
          nullable: true
        customer_device:
          allOf:
            - $ref: '#/components/schemas/CustomerDeviceData'
          nullable: true
        issuer:
          allOf:
            - $ref: '#/components/schemas/IssuerData'
          nullable: true
        acquirer:
          allOf:
            - $ref: '#/components/schemas/AcquirerData'
          nullable: true
      additionalProperties: false
    ThreeDsDecisionRuleExecuteResponse:
      type: object
      description: Represents the response from executing a 3DS decision rule.
      required:
        - decision
      properties:
        decision:
          $ref: '#/components/schemas/ThreeDSDecision'
    PaymentData:
      type: object
      description: Represents the payment data used in the 3DS decision rule.
      required:
        - amount
        - currency
      properties:
        amount:
          type: integer
          format: int64
          description: The amount of the payment in minor units (e.g., cents for USD).
        currency:
          $ref: '#/components/schemas/Currency'
    PaymentMethodMetaData:
      type: object
      description: >-
        Represents metadata about the payment method used in the 3DS decision
        rule.
      required:
        - card_network
      properties:
        card_network:
          $ref: '#/components/schemas/CardNetwork'
    CustomerDeviceData:
      type: object
      description: >-
        Represents data about the customer's device used in the 3DS decision
        rule.
      properties:
        platform:
          allOf:
            - $ref: '#/components/schemas/CustomerDevicePlatform'
          nullable: true
        device_type:
          allOf:
            - $ref: '#/components/schemas/CustomerDeviceType'
          nullable: true
        display_size:
          allOf:
            - $ref: '#/components/schemas/CustomerDeviceDisplaySize'
          nullable: true
    IssuerData:
      type: object
      description: Represents data about the issuer used in the 3DS decision rule.
      required:
        - country
      properties:
        name:
          type: string
          description: The name of the issuer.
          nullable: true
        country:
          $ref: '#/components/schemas/Country'
    AcquirerData:
      type: object
      description: Represents data about the acquirer used in the 3DS decision rule.
      required:
        - country
      properties:
        country:
          $ref: '#/components/schemas/Country'
        fraud_rate:
          type: number
          format: double
          description: The fraud rate associated with the acquirer.
          nullable: true
    ThreeDSDecision:
      type: string
      description: Enum representing the possible outcomes of the 3DS Decision Rule Engine.
      enum:
        - no_three_ds
        - challenge_requested
        - challenge_preferred
        - three_ds_exemption_requested_tra
        - three_ds_exemption_requested_low_value
        - issuer_three_ds_exemption_requested
    Currency:
      type: string
      description: >-
        The three-letter ISO 4217 currency code (e.g., "USD", "EUR") for the
        payment amount. This field is mandatory for creating a payment.
      enum:
        - AED
        - AFN
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BRL
        - BSD
        - BTN
        - BWP
        - BYN
        - BZD
        - CAD
        - CDF
        - CHF
        - CLF
        - CLP
        - CNY
        - COP
        - CRC
        - CUC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ERN
        - ETB
        - EUR
        - FJD
        - FKP
        - GBP
        - GEL
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - INR
        - IQD
        - IRR
        - ISK
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KPW
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRU
        - MUR
        - MVR
        - MWK
        - MXN
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SDG
        - SEK
        - SGD
        - SHP
        - SLE
        - SLL
        - SOS
        - SRD
        - SSP
        - STD
        - STN
        - SVC
        - SYP
        - SZL
        - THB
        - TJS
        - TMT
        - TND
        - TOP
        - TRY
        - TTD
        - TWD
        - TZS
        - UAH
        - UGX
        - USD
        - UYU
        - UZS
        - VES
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XOF
        - XPF
        - YER
        - ZAR
        - ZMW
        - ZWL
    CardNetwork:
      type: string
      description: Indicates the card network.
      enum:
        - Visa
        - Mastercard
        - AmericanExpress
        - JCB
        - DinersClub
        - Discover
        - CartesBancaires
        - UnionPay
        - Interac
        - RuPay
        - Maestro
        - Star
        - Pulse
        - Accel
        - Nyce
    CustomerDevicePlatform:
      type: string
      enum:
        - web
        - android
        - ios
    CustomerDeviceType:
      type: string
      enum:
        - mobile
        - tablet
        - desktop
        - gaming_console
    CustomerDeviceDisplaySize:
      type: string
      enum:
        - size320x568
        - size375x667
        - size390x844
        - size414x896
        - size428x926
        - size768x1024
        - size834x1112
        - size834x1194
        - size1024x1366
        - size1280x720
        - size1366x768
        - size1440x900
        - size1920x1080
        - size2560x1440
        - size3840x2160
        - size500x600
        - size600x400
        - size360x640
        - size412x915
        - size800x1280
    Country:
      type: string
      enum:
        - Afghanistan
        - AlandIslands
        - Albania
        - Algeria
        - AmericanSamoa
        - Andorra
        - Angola
        - Anguilla
        - Antarctica
        - AntiguaAndBarbuda
        - Argentina
        - Armenia
        - Aruba
        - Australia
        - Austria
        - Azerbaijan
        - Bahamas
        - Bahrain
        - Bangladesh
        - Barbados
        - Belarus
        - Belgium
        - Belize
        - Benin
        - Bermuda
        - Bhutan
        - BoliviaPlurinationalState
        - BonaireSintEustatiusAndSaba
        - BosniaAndHerzegovina
        - Botswana
        - BouvetIsland
        - Brazil
        - BritishIndianOceanTerritory
        - BruneiDarussalam
        - Bulgaria
        - BurkinaFaso
        - Burundi
        - CaboVerde
        - Cambodia
        - Cameroon
        - Canada
        - CaymanIslands
        - CentralAfricanRepublic
        - Chad
        - Chile
        - China
        - ChristmasIsland
        - CocosKeelingIslands
        - Colombia
        - Comoros
        - Congo
        - CongoDemocraticRepublic
        - CookIslands
        - CostaRica
        - CotedIvoire
        - Croatia
        - Cuba
        - Curacao
        - Cyprus
        - Czechia
        - Denmark
        - Djibouti
        - Dominica
        - DominicanRepublic
        - Ecuador
        - Egypt
        - ElSalvador
        - EquatorialGuinea
        - Eritrea
        - Estonia
        - Ethiopia
        - FalklandIslandsMalvinas
        - FaroeIslands
        - Fiji
        - Finland
        - France
        - FrenchGuiana
        - FrenchPolynesia
        - FrenchSouthernTerritories
        - Gabon
        - Gambia
        - Georgia
        - Germany
        - Ghana
        - Gibraltar
        - Greece
        - Greenland
        - Grenada
        - Guadeloupe
        - Guam
        - Guatemala
        - Guernsey
        - Guinea
        - GuineaBissau
        - Guyana
        - Haiti
        - HeardIslandAndMcDonaldIslands
        - HolySee
        - Honduras
        - HongKong
        - Hungary
        - Iceland
        - India
        - Indonesia
        - IranIslamicRepublic
        - Iraq
        - Ireland
        - IsleOfMan
        - Israel
        - Italy
        - Jamaica
        - Japan
        - Jersey
        - Jordan
        - Kazakhstan
        - Kenya
        - Kiribati
        - KoreaDemocraticPeoplesRepublic
        - KoreaRepublic
        - Kuwait
        - Kyrgyzstan
        - LaoPeoplesDemocraticRepublic
        - Latvia
        - Lebanon
        - Lesotho
        - Liberia
        - Libya
        - Liechtenstein
        - Lithuania
        - Luxembourg
        - Macao
        - MacedoniaTheFormerYugoslavRepublic
        - Madagascar
        - Malawi
        - Malaysia
        - Maldives
        - Mali
        - Malta
        - MarshallIslands
        - Martinique
        - Mauritania
        - Mauritius
        - Mayotte
        - Mexico
        - MicronesiaFederatedStates
        - MoldovaRepublic
        - Monaco
        - Mongolia
        - Montenegro
        - Montserrat
        - Morocco
        - Mozambique
        - Myanmar
        - Namibia
        - Nauru
        - Nepal
        - Netherlands
        - NewCaledonia
        - NewZealand
        - Nicaragua
        - Niger
        - Nigeria
        - Niue
        - NorfolkIsland
        - NorthernMarianaIslands
        - Norway
        - Oman
        - Pakistan
        - Palau
        - PalestineState
        - Panama
        - PapuaNewGuinea
        - Paraguay
        - Peru
        - Philippines
        - Pitcairn
        - Poland
        - Portugal
        - PuertoRico
        - Qatar
        - Reunion
        - Romania
        - RussianFederation
        - Rwanda
        - SaintBarthelemy
        - SaintHelenaAscensionAndTristandaCunha
        - SaintKittsAndNevis
        - SaintLucia
        - SaintMartinFrenchpart
        - SaintPierreAndMiquelon
        - SaintVincentAndTheGrenadines
        - Samoa
        - SanMarino
        - SaoTomeAndPrincipe
        - SaudiArabia
        - Senegal
        - Serbia
        - Seychelles
        - SierraLeone
        - Singapore
        - SintMaartenDutchpart
        - Slovakia
        - Slovenia
        - SolomonIslands
        - Somalia
        - SouthAfrica
        - SouthGeorgiaAndTheSouthSandwichIslands
        - SouthSudan
        - Spain
        - SriLanka
        - Sudan
        - Suriname
        - SvalbardAndJanMayen
        - Swaziland
        - Sweden
        - Switzerland
        - SyrianArabRepublic
        - TaiwanProvinceOfChina
        - Tajikistan
        - TanzaniaUnitedRepublic
        - Thailand
        - TimorLeste
        - Togo
        - Tokelau
        - Tonga
        - TrinidadAndTobago
        - Tunisia
        - Turkey
        - Turkmenistan
        - TurksAndCaicosIslands
        - Tuvalu
        - Uganda
        - Ukraine
        - UnitedArabEmirates
        - UnitedKingdomOfGreatBritainAndNorthernIreland
        - UnitedStatesOfAmerica
        - UnitedStatesMinorOutlyingIslands
        - Uruguay
        - Uzbekistan
        - Vanuatu
        - VenezuelaBolivarianRepublic
        - Vietnam
        - VirginIslandsBritish
        - VirginIslandsUS
        - WallisAndFutuna
        - WesternSahara
        - Yemen
        - Zambia
        - Zimbabwe
  securitySchemes:
    api_key:
      type: apiKey
      in: header
      name: api-key
      description: >-
        Use the API key created under your merchant account from the PaymntCloud
        dashboard. API key is used to authenticate API requests from your
        merchant server only. Don't expose this key on a website or embed it in
        a mobile application.

````